# asm-memcpy

## Условие задачи

Реализуйте на языке ассемблера x86-64 функцию с сигнатурой:
```c
extern void* my_memcpy(void* dest, const void* src, uint32_t count);
```

Эта функция аналогична [memcpy](https://en.cppreference.com/w/c/string/byte/memcpy),
в частности, гарантируется, что dest и src являются корректными указателями на count байт,
их области памяти не перекрываются.

При реализации пользуйтесь `calling conventions`.

Запрещается вызывать функции из стандартной библиотеки Си. Часть тестов будет компилироваться без
использования стандартной библиотеки.

Эффективная реализация предполагает копирование данных блоками по 8 байт (размер регистра). Это
также проверяется тестами в следующем смысле: один из тестов измеряет время работы функции на
больших данных и проверяет TL. При этом не гарантируется, что count кратно 8.

## Замечания

В этой задаче, как и в задаче asm-add, часть тестов проверяет отсутствие
ошибок неопределённого поведения при работе с регистрами.

Обратите внимание на тип аргумента count. Он отличается от типа того же аргумента
в стандартной функции memcpy. Решение должно использовать регистр правильного размера.
