# asm-add

## Условие задачи

Реализуйте на языке ассемблера armv8 (AArch64) функцию с сигнатурой:
```c
extern int64_t add(int64_t left, int64_t right);
```
Эта функция выполняет сложение двух чисел.

## Замечания

Поясним, для чего нужны два закрытых теста: `Сleaning registers test` и `Saving registers test`.
Они предназначены для детерминированности проверки решения, в частности, если в каком-то регистре
случайно оказалось подходящее значение, но это ничем не гарантируется, тесты должны это поймать,
если был изменён регистр, который функция обязана сохранять, тесты должны это поймать.

В основном студенты, в том числе и автор данной задачи, используют устройства с архитектурой x86.
В таком случае для компиляции и запуска программ под ARM потребуется кросс-компиляция и эмуляция.
Для локального тестирования можно установить следующие инструменты:
- для Ubuntu:
```shell
sudo apt install gcc-aarch64-linux-gnu
sudo apt install qemu-user
```
- для Manjaro:
```shell
sudo pacman -S aarch64-linux-gnu-gcc
sudo pacman -S qemu-full qemu-user
```
В случае использования других инструментов, поправьте соответствующим образом Makefile.
